CMAKE_MINIMUM_REQUIRED ( VERSION 2.4.0 )

PROJECT(Lilanci C)
# -DINSTALLLESS=path we don't want to install it anywhere, just run it from
# data in source tree, path is path to source
SET( APPNAME "lilanci" )


IF ( INSTALLLESS )
	MESSAGE ( "*****************************")
	MESSAGE ( "INSTALLLESS")
	MESSAGE ( "please don't run make install" )
	MESSAGE ( "*****************************")

	SET ( CMAKE_CONF_PATH "/etc" CACHE PATH "Config path prefix" )
	SET ( CMAKE_INSTALL_PREFIX "/usr/local/" CACHE PATH "Install path prefix" )
	SET ( CMAKE_DOC_PATH "${INSTALLLESS}/doc" CACHE PATH "Data path prefix" )
	SET ( CMAKE_LOCALE_PATH "${INSTALLLESS}/locale" CACHE PATH "Locale path prefix" )
	SET ( CMAKE_DATA_PATH "${INSTALLLESS}/" CACHE PATH "Data path prefix" )
	SET ( CMAKE_DATA_PATH_DIR "${INSTALLLESS}/" CACHE PATH "Data path prefix" )
	SET ( CMAKE_LIB_PATH "${INSTALLLESS}/lib/" CACHE PATH "Library path prefix" )
	SET ( LIB_INSTALL_DIR "${INSTALLLESS}" )
	SET ( CMAKE_FONT "${INSTALLLESS}/font/DejaVuSans.ttf" CACHE PATH "Font" )
	SET ( CMAKE_INSTALL_ETCDIR ${CMAKE_CONF_PATH} )
	SET ( CMAKE_INSTALL_BINDIR bin )
	SET ( CMAKE_INSTALL_LOCALEDIR ${CMAKE_LOCALE_PATH} )
	SET ( CMAKE_INSTALL_DATADIR ${CMAKE_DATA_PATH} )
	SET ( CMAKE_INSTALL_DATADIRDIR ${CMAKE_DATA_PATH_DIR} )
	SET ( CMAKE_INSTALL_LIBDIR ${LIB_INSTALL_DIR} )
	SET ( CMAKE_INSTALL_DOCDIR ${CMAKE_DOC_PATH} )
ELSE ( INSTALLLESS )
	SET ( CMAKE_CONF_PATH "/etc" CACHE PATH "Config path prefix" )
	SET ( CMAKE_INSTALL_PREFIX "/usr/local/" CACHE PATH "Install path prefix" )
	SET ( CMAKE_DOC_PATH "${CMAKE_INSTALL_PREFIX}/share/doc" CACHE PATH "Data path prefix" )
	SET ( CMAKE_LOCALE_PATH "${CMAKE_INSTALL_PREFIX}/share/locale" CACHE PATH "Locale path prefix" )
	SET ( CMAKE_DATA_PATH "${CMAKE_INSTALL_PREFIX}/share/" CACHE PATH "Data path prefix" )
	SET ( CMAKE_DATA_PATH_DIR "${CMAKE_DATA_PATH}/${APPNAME}/" CACHE PATH "Data path" )
	SET ( CMAKE_LIB_PATH "${CMAKE_INSTALL_PREFIX}/lib/" CACHE PATH "Library path prefix" )
	SET ( LIB_INSTALL_DIR "${CMAKE_LIB_PATH}" )

	SET ( CMAKE_FONT "${CMAKE_DATA_PATH}/${APPNAME}/font/DejaVuSans.ttf" CACHE PATH "Font" )
	SET ( CMAKE_INSTALL_ETCDIR ${CMAKE_CONF_PATH} )
	SET ( CMAKE_INSTALL_BINDIR bin )
	SET ( CMAKE_INSTALL_LOCALEDIR ${CMAKE_LOCALE_PATH} )
	SET ( CMAKE_INSTALL_DATADIR ${CMAKE_DATA_PATH} )
	SET ( CMAKE_INSTALL_DATADIRDIR ${CMAKE_DATA_PATH_DIR} )
	SET ( CMAKE_INSTALL_LIBDIR ${LIB_INSTALL_DIR} )
	SET ( CMAKE_INSTALL_DOCDIR ${CMAKE_DOC_PATH} )
ENDIF ( INSTALLLESS )

#INCLUDE(UsePkgConfig)
#PKGCONFIG(glu GLU_INCLUDE_DIR GLU_LIBRARY_DIR GLU_LINK_FLAGS GLU_CFLAGS)
#PKGCONFIG(sdl SDL_INCLUDE_DIR SDL_LIBRARY_DIR SDL_LINK_FLAGS SDL_CFLAGS)
#PKGCONFIG(cairo CAIRO_INCLUDE_DIR CAIRO_LIBRARY_DIR CAIRO_LINK_FLAGS CAIRO_CFLAGS)
#PKGCONFIG(librsvg-2.0 RSVG_INCLUDE_DIR RSVG_LIBRARY_DIR RSVG_LINK_FLAGS RSVG_CFLAGS)
#FIND_PACKAGE ( GLU REQUIRED )
INCLUDE(FindPkgConfig OPTIONAL RESULT_VARIABLE PKGCONFIGFOUND)
FIND_PACKAGE ( OpenGL REQUIRED )
FIND_PACKAGE ( SDL REQUIRED )
FIND_PACKAGE ( SDL_mixer REQUIRED )
INCLUDE_DIRECTORIES (
	${SDL_INCLUDE_DIR}
	${OPENGL_INCLUDE_DIR}
	${SDLMIXER_INCLUDE_DIR}
)
LINK_LIBRARIES (
	${SDL_LIBRARY}
	${OPENGL_LIBRARY}
	${SDLMIXER_LIBRARY}
)
IF ( "${PKGCONFIGFOUND}" STREQUAL "NOTFOUND")
	MESSAGE ("We don't have FindPkgConfig, failing back on UsePkgConfig")
	INCLUDE(UsePkgConfig)
	PKGCONFIG(cairo CAIRO_INCLUDE_DIRS CAIRO_LIBRARY_DIR CAIRO_LINK_FLAGS CAIRO_CFLAGS)
	PKGCONFIG(librsvg-2.0 RSVG_INCLUDE_DIRS RSVG_LIBRARY_DIR RSVG_LINK_FLAGS RSVG_CFLAGS)
	PKGCONFIG(ftgl FTGL_INCLUDE_DIRS FTGL_LIBRARY_DIR FTGL_LINK_FLAGS FTGL_CFLAGS)
ELSE ( "${PKGCONFIGFOUND}" STREQUAL "NOTFOUND")
	PKG_CHECK_MODULES( CAIRO cairo )
	PKG_CHECK_MODULES( RSVG librsvg-2.0 )
	PKG_CHECK_MODULES( FTGL ftgl )
	LINK_LIBRARIES (
		${CAIRO_LIBRARIES}
		${RSVG_LIBRARIES}
		${FTGL_LIBRARIES}
	)
	INCLUDE_DIRECTORIES (
		${CAIRO_INCLUDE_DIRS}
		${RSVG_INCLUDE_DIRS}
		${FTGL_INCLUDE_DIRS}
		${CMAKE_BINARY_DIR}
	)
ENDIF ( "${PKGCONFIGFOUND}" STREQUAL "NOTFOUND")


#LINK_DIRECTORIES(${SDL_LIBRARY_DIR} ${CAIRO_LIBRARY_DIR} ${RSVG_LIBRARY_DIR} ${GLU_LIBRARY_DIR})
#INCLUDE_DIRECTORIES(${SDL_INCLUDE_DIR} ${CAIRO_INCLUDE_DIR} ${RSVG_INCLUDE_DIR} ${GLU_INCLUDE_DIR})

ADD_EXECUTABLE(elilanci elilanci.c geometry.c gr.c config.c map.c snd.c particle.c font.c)
IF ( "${PKGCONFIGFOUND}" STREQUAL "NOTFOUND")
	SET_TARGET_PROPERTIES( elilanci PROPERTIES LINK_FLAGS "${CAIRO_LINK_FLAGS}	${RSVG_LINK_FLAGS} ${FTGL_LINK_FLAGS}")
	SET_TARGET_PROPERTIES( elilanci PROPERTIES COMPILE_FLAGS "${CAIRO_CFLAGS}	${RSVG_CFLAGS} ${FTGL_CFLAGS}")
ENDIF ( "${PKGCONFIGFOUND}" STREQUAL "NOTFOUND")

ADD_SUBDIRECTORY (graphics)
ADD_SUBDIRECTORY (sounds)
CONFIGURE_FILE ( path.h.in path.h)
install(TARGETS elilanci
	RUNTIME DESTINATION bin
)

CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
